/* definition file for external resources */
#include <stdio.h>

#define	C_COMPILER	0
#define	EG2C		1
#define	TMP_DIR		2
#define	TMP_EGL_FILE	3
#define	C_SOURCE_FILE	4
#define	SIM_NAME	5

#define	NB_RESOURCES	6

#ifndef RESOURCES
#define RESOURCES

char	*Resource_Name[] = {
	"C_COMPILER",
	"EG2C",
	"TMP_DIR",
	"TMP_EGL_FILE",
	"C_SOURCE_FILE",
	"SIM_NAME",
	NULL };

#include <unistd.h>

int	Access_Code[] = {
	X_OK,
	X_OK,
	W_OK,
	W_OK,
	R_OK,
	W_OK };

char	*Default_Value[] = {
	"gcc",
	"eg2c",
	"/tmp",
	"/tmp/eg_sim.egl",
	"@lib/eg_sim/skeletton.c",
	"EG_Sim",
	NULL };

boolean	Is_Essential[] = {
	TRUE,
	TRUE,
	FALSE,
	FALSE,
	TRUE,
	FALSE };

#endif
