
/*  A Bison parser, made from pnl.y with Bison version GNU Bison version 1.22
  */

#define YYBISON 1  /* Identify Bison output.  */

#define	TSIZE	258
#define	PSIZE	259
#define	TMAX	260
#define	AFFECT	261
#define	INTGR	262
#define	SEP	263
#define	ENDINSTR	264
#define	SLASH	265
#define	RAND	266
#define	CYCL	267
#define	COMP	268
#define	PRIO	269
#define	TRANS	270
#define	PLACE	271
#define	SUBMO	272
#define	INHIB	273
#define	EXPORT	274
#define	IS	275
#define	IN	276
#define	OUT	277
#define	BIND	278
#define	SUBM	279
#define	INFILE	280
#define	PARB	281
#define	PARE	282
#define	REP	283
#define	REAL	284
#define	STRING	285
#define	NAME	286
#define	EXPO	287
#define	ERLG	288
#define	BERN	289
#define	GEOM0	290
#define	GEOM1	291
#define	UNIF	292
#define	CST	293
#define	DISC	294
#define	ONOFF	295
#define	IPP	296
#define	HEXP	297
#define	LOGNO	298
#define	PARETO	299
#define	WEIBULL	300

#line 1 "pnl.y"


#include "pn.h"

#define YYDEBUG 1

extern boolean		Debug;
extern PetriNet		*The_Petri_Net;

extern PetriNet 	*Parse_PN();
extern Tr_Des	 	*Parse_Transition();
extern Tr_Des	 	*Add_Trans_Sons();
extern Pl_Des		*Parse_Place();
extern Liste_Link	Parse_Place_Head();	/* reutilisation abusive*/
						/* du type...		*/
extern Liste_Link	Parse_Link();
extern Subm_Des		*Parse_Submodel();
extern Pl_Des		*Add_Place_Sons();
extern Population	*Parse_Init_Pop();
extern Law_Desc		Parse_Law(char Nom, Liste_Reel Params, 
				  Liste_Reel Params2, Liste_Loi The_SubLaws);
extern Routing_Desc	Parse_Routing();
extern Listes		Append_Transition();
extern Listes		Append_Place();
extern Liste_Subm	Append_Submodel();
extern Liste_Subm	Read_Submodel_Files();
extern Liste_Reel	Append_Real();
extern Liste_Reel	Concat_Real_Lists();
extern Liste_Reel	Expand_Real_List();
extern Liste_Entier	Append_Integer();
extern Liste_Link	Append_Link();
extern Liste_Loi	Append_Law();
extern Liste_Address	Append_Address();
extern Address		Parse_Address();
extern Binding		Parse_Binding();
extern Binding		Make_Binding();
extern Binding		Append_Binding();

#line 42 "pnl.y"
typedef union{
	int		ival;
	double		rval;
	char		*sval;
	PetriNet	*un_reseau;
	Law_Desc	loi;
	Pl_Des		*place;
	Tr_Des		*transition;
	Subm_Des	*submodel;
  	Routing_Desc	routing;
	Parametres	params;
	Listes		ptlist;
	Population	*pop;
  	Liste_Subm	slist;
	Liste_Reel	rlist;
  	Liste_Entier	ilist;
  	Liste_Link	llist;
	Liste_Loi	Llist;
  	Address		aval;
  	Liste_Address	alist;
  	Binding		bval;
} YYSTYPE;

#ifndef YYLTYPE
typedef
  struct yyltype
    {
      int timestamp;
      int first_line;
      int first_column;
      int last_line;
      int last_column;
      char *text;
   }
  yyltype;

#define YYLTYPE yyltype
#endif

#ifndef YYDEBUG
#define YYDEBUG 1
#endif

#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		178
#define	YYFLAG		-32768
#define	YYNTBASE	46

#define YYTRANSLATE(x) ((unsigned)(x) <= 300 ? yytranslate[x] : 81)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     2,     3,     4,     5,
     6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
    26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
    36,    37,    38,    39,    40,    41,    42,    43,    44,    45
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     4,    10,    14,    17,    21,    25,    29,    32,    33,
    36,    38,    43,    45,    47,    50,    51,    57,    64,    67,
    70,    72,    74,    78,    79,    86,    91,    94,    98,   103,
   110,   115,   120,   126,   130,   135,   137,   140,   142,   144,
   146,   149,   152,   155,   158,   161,   165,   168,   171,   174,
   177,   185,   188,   191,   198,   201,   206,   211,   217,   219,
   225,   228,   230,   231,   233,   237,   239,   243,   245,   248,
   250,   253,   256,   260,   263,   266,   271,   274,   277,   279,
   281,   284,   285,   287,   288,   291,   293
};

static const short yyrhs[] = {    47,
    57,    51,     0,    47,    54,    57,    78,    51,     0,    48,
    49,    50,     0,    48,    49,     0,     3,     6,     7,     0,
     4,     6,     7,     0,     5,     6,     7,     0,    19,    52,
     0,     0,    52,    53,     0,    53,     0,    75,    20,    76,
     9,     0,    55,     0,    56,     0,    55,    56,     0,     0,
    24,     7,    25,    30,     9,     0,    24,     7,    66,    25,
    30,     9,     0,    57,    59,     0,    57,    61,     0,    59,
     0,    61,     0,    26,     7,    27,     0,     0,    58,    15,
    60,     8,    72,     9,     0,    58,    15,    60,     9,     0,
    64,    67,     0,    64,    66,    67,     0,    64,    66,    66,
    67,     0,    58,    16,    62,     8,    72,     9,     0,    58,
    16,    62,     9,     0,    63,    67,    68,    69,     0,    63,
    66,    67,    68,    69,     0,    63,    67,    68,     0,    63,
    66,    67,    68,     0,    65,     0,    65,    66,     0,     7,
     0,     7,     0,    30,     0,    32,    70,     0,    38,    70,
     0,    34,    70,     0,    35,    70,     0,    36,    70,     0,
    33,     7,    70,     0,    37,    70,     0,    43,    70,     0,
    44,    70,     0,    45,    70,     0,    39,    26,    70,    27,
    26,    70,    27,     0,    42,    70,     0,    40,    70,     0,
    41,    26,    29,     8,    71,    27,     0,     7,    70,     0,
    11,    26,    70,    27,     0,    12,    26,    77,    27,     0,
    13,    14,    26,    77,    27,     0,    13,     0,    26,    29,
    28,     7,    27,     0,    70,    29,     0,    29,     0,     0,
    67,     0,    71,     8,    67,     0,    73,     0,    72,     8,
    73,     0,    74,     0,    74,    18,     0,    76,     0,    76,
     7,     0,    76,    66,     0,    76,     7,    66,     0,    21,
     7,     0,    22,     7,     0,    17,     7,    10,    75,     0,
    16,     7,     0,    15,     7,     0,     7,     0,    76,     0,
    77,    76,     0,     0,    79,     0,     0,    79,    80,     0,
    80,     0,    17,     7,    10,    75,     8,    72,     9,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   102,   130,   143,   149,   156,   161,   166,   171,   175,   181,
   185,   192,   198,   205,   209,   214,   220,   224,   231,   235,
   238,   241,   246,   251,   258,   262,   267,   271,   274,   279,
   283,   288,   294,   301,   307,   316,   321,   327,   330,   333,
   337,   341,   345,   349,   353,   357,   362,   366,   370,   374,
   378,   382,   386,   390,   397,   405,   409,   412,   415,   421,
   424,   427,   430,   435,   438,   451,   454,   459,   462,   484,
   487,   490,   493,   498,   502,   508,   512,   516,   520,   526,
   530,   534,   540,   544,   550,   554,   565
};

static const char * const yytname[] = {   "$","error","$illegal.","TSIZE","PSIZE",
"TMAX","AFFECT","INTGR","SEP","ENDINSTR","SLASH","RAND","CYCL","COMP","PRIO",
"TRANS","PLACE","SUBMO","INHIB","EXPORT","IS","IN","OUT","BIND","SUBM","INFILE",
"PARB","PARE","REP","REAL","STRING","NAME","EXPO","ERLG","BERN","GEOM0","GEOM1",
"UNIF","CST","DISC","ONOFF","IPP","HEXP","LOGNO","PARETO","WEIBULL","reseau",
"declarations","t_taille_dcl","p_taille_dcl","duree_dcl","io_dcl","io_list",
"one_io","submodel_dcl","submodel_list","one_submodel","liste_trucs","tag","a_transition",
"transition_dcl","a_place","place_dcl","place_head","trans_id","place_id","name",
"loi_dcl","pop_dcl","routing_dcl","real_list","law_list","link_list","one_link",
"one_link_descr","io_address","address","address_list","binding_dcl","binding_list",
"a_binding",""
};
#endif

static const short yyr1[] = {     0,
    46,    46,    47,    47,    48,    49,    50,    51,    51,    52,
    52,    53,    54,    55,    55,    55,    56,    56,    57,    57,
    57,    57,    58,    58,    59,    59,    60,    60,    60,    61,
    61,    62,    62,    62,    62,    63,    63,    64,    65,    66,
    67,    67,    67,    67,    67,    67,    67,    67,    67,    67,
    67,    67,    67,    67,    68,    69,    69,    69,    69,    70,
    70,    70,    70,    71,    71,    72,    72,    73,    73,    74,
    74,    74,    74,    75,    75,    76,    76,    76,    76,    77,
    77,    77,    78,    78,    79,    79,    80
};

static const short yyr2[] = {     0,
     3,     5,     3,     2,     3,     3,     3,     2,     0,     2,
     1,     4,     1,     1,     2,     0,     5,     6,     2,     2,
     1,     1,     3,     0,     6,     4,     2,     3,     4,     6,
     4,     4,     5,     3,     4,     1,     2,     1,     1,     1,
     2,     2,     2,     2,     2,     3,     2,     2,     2,     2,
     7,     2,     2,     6,     2,     4,     4,     5,     1,     5,
     2,     1,     0,     1,     3,     1,     3,     1,     2,     1,
     2,     2,     3,     2,     2,     4,     2,     2,     1,     1,
     2,     0,     1,     0,     2,     1,     7
};

static const short yydefact[] = {     0,
     0,    16,     0,     0,     0,     0,    24,    13,    14,    24,
     0,    21,    22,     0,     4,     5,     0,     0,    24,    15,
     0,     1,    19,    20,     0,     0,     0,     0,     3,     0,
    40,     0,    23,     0,     9,    83,    86,     0,     0,     8,
    11,     0,    38,     0,     0,    39,     0,     0,    36,     6,
     0,     0,     0,     0,     2,    85,    74,    75,    10,     0,
     0,    26,    63,     0,    63,    63,    63,    63,    63,     0,
    63,     0,    63,    63,    63,    63,     0,    27,     0,    31,
     0,     0,    37,     7,    17,     0,     0,    79,     0,     0,
     0,     0,     0,    66,    68,    70,     0,    62,    41,    63,
    43,    44,    45,    47,    42,    63,    53,     0,    52,    48,
    49,    50,     0,    28,     0,     0,    63,    34,    18,     0,
    78,    77,     0,    12,     0,    25,    69,    71,    72,     0,
    61,    46,     0,     0,    29,    30,    35,    55,     0,     0,
    59,    32,     0,     0,    67,    73,     0,     0,     0,    33,
    63,    82,     0,     0,    76,     0,    63,    64,     0,     0,
    80,     0,    82,    87,    60,     0,     0,    54,    56,    57,
    81,     0,    51,    65,    58,     0,     0,     0
};

static const short yydefgoto[] = {   176,
     2,     3,    15,    29,    22,    40,    41,     7,     8,     9,
    10,    11,    12,    44,    13,    47,    48,    45,    49,    32,
    78,   118,   142,    99,   159,    93,    94,    95,    42,    96,
   162,    35,    36,    37
};

static const short yypact[] = {    28,
    32,    29,    38,    45,    53,    89,    44,    92,-32768,    20,
    48,-32768,-32768,    96,   112,-32768,     2,    91,     9,-32768,
    78,-32768,-32768,-32768,   127,   128,   129,   131,-32768,   108,
-32768,   114,-32768,   133,   122,   125,-32768,   136,   137,    78,
-32768,   126,-32768,    97,    42,-32768,    99,    42,   115,-32768,
   140,   139,   119,   141,-32768,-32768,-32768,-32768,-32768,    41,
    41,-32768,    33,   143,    33,    33,    33,    33,    33,   130,
    33,   132,    33,    33,    33,    33,    42,-32768,    41,-32768,
    88,   145,-32768,-32768,-32768,   144,    78,-32768,   147,   148,
   150,   151,   101,-32768,   146,    10,   134,-32768,   138,    33,
   138,   138,   138,   138,   138,    33,   138,   142,   138,   138,
   138,   138,    88,-32768,   103,   145,    33,    56,-32768,   153,
-32768,-32768,   149,-32768,    41,-32768,-32768,   115,-32768,   152,
-32768,   138,    62,   154,-32768,-32768,    56,   138,   155,   156,
   158,-32768,    41,    78,-32768,-32768,   159,   157,    88,-32768,
    33,    41,   160,   106,-32768,   161,    33,-32768,    17,    63,
-32768,     7,    41,-32768,-32768,    68,    88,-32768,-32768,-32768,
-32768,    34,-32768,-32768,-32768,   165,   168,-32768
};

static const short yypgoto[] = {-32768,
-32768,-32768,-32768,-32768,   135,-32768,   162,-32768,-32768,   166,
   169,-32768,    11,-32768,    26,-32768,-32768,-32768,-32768,   -30,
   -48,    57,    40,   -63,-32768,   -72,    50,-32768,   -71,   -59,
     6,-32768,-32768,   163
};


#define	YYLAST		202


static const short yytable[] = {    82,
    92,   101,   102,   103,   104,   105,   115,   107,   -84,   109,
   110,   111,   112,    88,    77,   120,   128,    81,    83,    -9,
    23,    89,    90,    91,   167,    34,    30,   -84,   114,    23,
     1,    31,   116,   170,     6,    24,   132,     4,    21,    31,
    88,    14,   133,   168,    24,     6,   113,    88,    89,    90,
    91,    16,     5,   138,     6,    89,    90,    91,    97,    17,
   175,    98,    25,    26,   135,   129,   139,   140,   141,     6,
   154,    31,   155,    63,    64,    65,    66,    67,    68,    69,
    70,    71,    72,    73,    74,    75,    76,   160,   148,   169,
   131,   131,   161,   166,   173,    18,   131,   146,    38,    39,
   158,    27,   171,   161,    61,    62,    79,    80,   125,   126,
   125,   136,   171,   125,   164,     5,    28,    33,   174,    63,
    64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
    74,    75,    76,    43,    46,    50,    51,    52,    53,    54,
    21,    34,    57,    58,    31,    60,    84,    85,    86,   100,
    87,   117,   119,   121,   122,   106,   123,   108,   144,   124,
   143,   149,   130,   127,   177,   156,   131,   178,   172,    55,
   134,   153,   137,    20,   145,    19,   150,     0,     0,   147,
   151,   152,   157,     0,     0,   163,     0,   165,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,    56,     0,
     0,    59
};

static const short yycheck[] = {    48,
    60,    65,    66,    67,    68,    69,    79,    71,     0,    73,
    74,    75,    76,     7,    45,    87,     7,    48,    49,     0,
    10,    15,    16,    17,     8,    17,    25,    19,    77,    19,
     3,    30,    81,    27,    26,    10,   100,     6,    19,    30,
     7,     4,   106,    27,    19,    26,    77,     7,    15,    16,
    17,     7,    24,   117,    26,    15,    16,    17,    26,     7,
    27,    29,    15,    16,   113,    96,    11,    12,    13,    26,
   143,    30,   144,    32,    33,    34,    35,    36,    37,    38,
    39,    40,    41,    42,    43,    44,    45,   151,    27,    27,
    29,    29,   152,   157,    27,     7,    29,   128,    21,    22,
   149,     6,   162,   163,     8,     9,     8,     9,     8,     9,
     8,     9,   172,     8,     9,    24,     5,    27,   167,    32,
    33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
    43,    44,    45,     7,     7,     7,     6,    30,    25,     7,
    19,    17,     7,     7,    30,    20,     7,     9,    30,     7,
    10,     7,     9,     7,     7,    26,     7,    26,    10,     9,
     8,     8,    29,    18,     0,     7,    29,     0,   163,    35,
    29,    14,   116,     8,   125,     7,   137,    -1,    -1,    28,
    26,    26,    26,    -1,    -1,    26,    -1,    27,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    36,    -1,
    -1,    40
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/lib/bison.simple"

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Bob Corbett and Richard Stallman

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 1, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */


#ifndef alloca
#ifdef __GNUC__
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi)
#include <alloca.h>
#else /* not sparc */
#if defined (MSDOS) && !defined (__TURBOC__)
#include <malloc.h>
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
#include <malloc.h>
 #pragma alloca
#else /* not MSDOS, __TURBOC__, or _AIX */
#ifdef __hpux
#ifdef __cplusplus
extern "C" {
void *alloca (unsigned int);
};
#else /* not __cplusplus */
void *alloca ();
#endif /* not __cplusplus */
#endif /* __hpux */
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc.  */
#endif /* not GNU C.  */
#endif /* alloca not defined.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	return(0)
#define YYABORT 	return(1)
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#define YYLEX		yylex(&yylval, &yylloc)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
int yyparse (void);
#endif

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_bcopy(FROM,TO,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_bcopy (from, to, count)
     char *from;
     char *to;
     int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_bcopy (char *from, char *to, int count)
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 184 "/usr/lib/bison.simple"
int
yyparse()
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
      yyss = (short *) alloca (yystacksize * sizeof (*yyssp));
      __yy_bcopy ((char *)yyss1, (char *)yyss, size * sizeof (*yyssp));
      yyvs = (YYSTYPE *) alloca (yystacksize * sizeof (*yyvsp));
      __yy_bcopy ((char *)yyvs1, (char *)yyvs, size * sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) alloca (yystacksize * sizeof (*yylsp));
      __yy_bcopy ((char *)yyls1, (char *)yyls, size * sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 1:
#line 103 "pnl.y"
{
		  	The_Petri_Net = 
			  Parse_PN( yyvsp[-2].params.T_Size, yyvsp[-2].params.P_Size, yyvsp[-2].params.Nb_Firings, 
				    yyvsp[-1].ptlist->Places, yyvsp[-1].ptlist->Transitions, 
				    yyvsp[0].bval, (Liste_Subm)NULL, (Binding)NULL );
			if ( Debug )
			  printf("Reseau ok\n");
		;
    break;}
case 2:
#line 132 "pnl.y"
{
		  	The_Petri_Net = 
			  Parse_PN( yyvsp[-4].params.T_Size, yyvsp[-4].params.P_Size, 0,
				    yyvsp[-2].ptlist->Places, yyvsp[-2].ptlist->Transitions, 
				    yyvsp[0].bval, yyvsp[-3].slist, yyvsp[-1].bval );
			free( yyvsp[-3].slist );
			if ( Debug )
			  printf("Reseau ok\n");
		;
    break;}
case 3:
#line 144 "pnl.y"
{	yyval.params.T_Size = yyvsp[-2].ival;
			yyval.params.P_Size = yyvsp[-1].ival;
			yyval.params.Nb_Firings = yyvsp[0].ival;
			printf("Warning: duration declaration is obsolete. Ignored.\n");
		;
    break;}
case 4:
#line 150 "pnl.y"
{	yyval.params.T_Size = yyvsp[-1].ival;
			yyval.params.P_Size = yyvsp[0].ival;
			yyval.params.Nb_Firings = 0;
		;
    break;}
case 5:
#line 157 "pnl.y"
{	yyval.ival = yyvsp[0].ival;
		;
    break;}
case 6:
#line 162 "pnl.y"
{	yyval.ival = yyvsp[0].ival;
		;
    break;}
case 7:
#line 167 "pnl.y"
{	yyval.ival = yyvsp[0].ival;
		;
    break;}
case 8:
#line 172 "pnl.y"
{
			yyval.bval = yyvsp[0].bval;
		;
    break;}
case 9:
#line 176 "pnl.y"
{
			yyval.bval = (Binding)NULL;
		;
    break;}
case 10:
#line 182 "pnl.y"
{
			yyval.bval = Append_Binding( yyvsp[-1].bval, yyvsp[0].bval );
		;
    break;}
case 11:
#line 187 "pnl.y"
{
			yyval.bval = Append_Binding( yyvsp[0].bval, (Binding)NULL );
		;
    break;}
case 12:
#line 193 "pnl.y"
{
			yyval.bval = Make_Binding( yyvsp[-3].aval, yyvsp[-1].aval, (Liste_Link)NULL );
		;
    break;}
case 13:
#line 199 "pnl.y"
{
		  /* $$ = Read_Submodel_Files( $1 ); */
		  yyval.slist = yyvsp[0].slist;
		;
    break;}
case 14:
#line 206 "pnl.y"
{
			yyval.slist = Append_Submodel( (Liste_Subm)NULL, yyvsp[0].submodel );
		;
    break;}
case 15:
#line 211 "pnl.y"
{
			yyval.slist = Append_Submodel( yyvsp[-1].slist, yyvsp[0].submodel );
		;
    break;}
case 16:
#line 215 "pnl.y"
{ 
			yyval.slist = (Liste_Subm)NULL;
		;
    break;}
case 17:
#line 221 "pnl.y"
{
			yyval.submodel = Parse_Submodel( yyvsp[-3].ival, yyvsp[-1].sval, "" );
		;
    break;}
case 18:
#line 226 "pnl.y"
{
			yyval.submodel = Parse_Submodel( yyvsp[-4].ival, yyvsp[-1].sval, yyvsp[-3].sval );
		;
    break;}
case 19:
#line 233 "pnl.y"
{	yyval.ptlist = Append_Transition( yyvsp[-1].ptlist, yyvsp[0].transition );
		;
    break;}
case 20:
#line 236 "pnl.y"
{	yyval.ptlist = Append_Place( yyvsp[-1].ptlist, yyvsp[0].place );
		;
    break;}
case 21:
#line 239 "pnl.y"
{	yyval.ptlist = Append_Transition( (Listes)NULL, yyvsp[0].transition );
		;
    break;}
case 22:
#line 242 "pnl.y"
{	yyval.ptlist = Append_Place( (Listes)NULL, yyvsp[0].place );
		;
    break;}
case 23:
#line 248 "pnl.y"
{
			yyval.ival = yyvsp[-1].ival;
		;
    break;}
case 24:
#line 252 "pnl.y"
{
			yyval.ival = 0;
		;
    break;}
case 25:
#line 260 "pnl.y"
{ 	yyval.transition = Add_Trans_Sons( yyvsp[-3].transition, yyvsp[-1].llist );
		;
    break;}
case 26:
#line 263 "pnl.y"
{ 	yyval.transition = yyvsp[-1].transition;
		;
    break;}
case 27:
#line 269 "pnl.y"
{ 	yyval.transition = Parse_Transition( yyvsp[-1].ival, yyvsp[0].loi, "", "" );
		;
    break;}
case 28:
#line 272 "pnl.y"
{ 	yyval.transition = Parse_Transition( yyvsp[-2].ival, yyvsp[0].loi, yyvsp[-1].sval, "" );
		;
    break;}
case 29:
#line 275 "pnl.y"
{ 	yyval.transition = Parse_Transition( yyvsp[-3].ival, yyvsp[0].loi, yyvsp[-2].sval, yyvsp[-1].sval );
		;
    break;}
case 30:
#line 281 "pnl.y"
{	yyval.place = Add_Place_Sons( yyvsp[-3].place, yyvsp[-1].llist );
		;
    break;}
case 31:
#line 284 "pnl.y"
{	yyval.place = yyvsp[-1].place;
		;
    break;}
case 32:
#line 289 "pnl.y"
{	yyval.place = Parse_Place( yyvsp[-3].llist, yyvsp[-2].loi, yyvsp[-1].pop, "", yyvsp[0].routing );
			if ( Debug )
				printf(" (%c)\n", 
				       (yyvsp[0].routing==NULL? '-' : yyvsp[0].routing->Type ) );
		;
    break;}
case 33:
#line 295 "pnl.y"
{	yyval.place = Parse_Place( yyvsp[-4].llist, yyvsp[-2].loi, yyvsp[-1].pop, yyvsp[-3].sval, yyvsp[0].routing );
			if ( Debug )
				printf("(a=\"%s\") (%c)\n", 
				       (yyvsp[-3].sval==NULL? "<nil>" : yyvsp[-3].sval), 
				       (yyvsp[0].routing==NULL? '-' : yyvsp[0].routing->Type ) );
		;
    break;}
case 34:
#line 302 "pnl.y"
{	yyval.place = Parse_Place( yyvsp[-2].llist, yyvsp[-1].loi, yyvsp[0].pop, "", 
						(Routing_Desc) NULL );
			if ( Debug )
				printf("\n");
		;
    break;}
case 35:
#line 308 "pnl.y"
{	yyval.place = Parse_Place( yyvsp[-3].llist, yyvsp[-1].loi, yyvsp[0].pop, yyvsp[-2].sval,
						(Routing_Desc) NULL );
			if ( Debug )
				printf("(a=\"%s\")\n",
				       (yyvsp[-2].sval==NULL? "<nil>" : yyvsp[-2].sval) );
		;
    break;}
case 36:
#line 317 "pnl.y"
{	yyval.llist = Parse_Place_Head( yyvsp[0].ival, "" );
			if ( Debug )
				printf("Place %d reconnue ", yyvsp[0].ival );
		;
    break;}
case 37:
#line 322 "pnl.y"
{	yyval.llist = Parse_Place_Head( yyvsp[-1].ival, yyvsp[0].sval );
			if ( Debug )
				printf("Place %s [%d] reconnue ",yyvsp[0].sval, yyvsp[-1].ival);
		;
    break;}
case 40:
#line 334 "pnl.y"
{	yyval.sval = yyvsp[0].sval;
		;
    break;}
case 41:
#line 338 "pnl.y"
{	yyval.loi = Parse_Law( 'E', yyvsp[0].rlist, (Liste_Reel)NULL,
					(Liste_Loi)NULL );
		;
    break;}
case 42:
#line 342 "pnl.y"
{	yyval.loi = Parse_Law( 'C', yyvsp[0].rlist, (Liste_Reel)NULL,
					(Liste_Loi)NULL );
		;
    break;}
case 43:
#line 346 "pnl.y"
{	yyval.loi = Parse_Law( 'B', yyvsp[0].rlist, (Liste_Reel)NULL,
					(Liste_Loi)NULL );
		;
    break;}
case 44:
#line 350 "pnl.y"
{	yyval.loi = Parse_Law( 'g', yyvsp[0].rlist, (Liste_Reel)NULL,
					(Liste_Loi)NULL );
		;
    break;}
case 45:
#line 354 "pnl.y"
{	yyval.loi = Parse_Law( 'G', yyvsp[0].rlist, (Liste_Reel)NULL,
					(Liste_Loi)NULL );
		;
    break;}
case 46:
#line 358 "pnl.y"
{	yyval.loi = Parse_Law( 'R', Append_Real( yyvsp[0].rlist, (double)yyvsp[-1].ival ),
					(Liste_Reel)NULL,
					(Liste_Loi)NULL );
		;
    break;}
case 47:
#line 363 "pnl.y"
{	yyval.loi = Parse_Law( 'U', yyvsp[0].rlist, (Liste_Reel)NULL,
					(Liste_Loi)NULL );
		;
    break;}
case 48:
#line 367 "pnl.y"
{	yyval.loi = Parse_Law( 'L', yyvsp[0].rlist, (Liste_Reel)NULL,
					(Liste_Loi)NULL );
		;
    break;}
case 49:
#line 371 "pnl.y"
{	yyval.loi = Parse_Law( 'p', yyvsp[0].rlist, (Liste_Reel)NULL,
					(Liste_Loi)NULL );
		;
    break;}
case 50:
#line 375 "pnl.y"
{	yyval.loi = Parse_Law( 'W', yyvsp[0].rlist, (Liste_Reel)NULL,
					(Liste_Loi)NULL );
		;
    break;}
case 51:
#line 379 "pnl.y"
{	yyval.loi = Parse_Law( 'D', yyvsp[-4].rlist, yyvsp[-1].rlist,
					(Liste_Loi)NULL );
		;
    break;}
case 52:
#line 383 "pnl.y"
{	yyval.loi = Parse_Law( 'H', yyvsp[0].rlist, (Liste_Reel)NULL,
					(Liste_Loi)NULL );
		;
    break;}
case 53:
#line 387 "pnl.y"
{	yyval.loi = Parse_Law( 'O', yyvsp[0].rlist, (Liste_Reel)NULL,
					(Liste_Loi)NULL );
		;
    break;}
case 54:
#line 391 "pnl.y"
{	yyval.loi = Parse_Law( 'P', 
					Append_Real( (Liste_Reel)NULL, yyvsp[-3].rval),
					(Liste_Reel)NULL, yyvsp[-1].Llist );
		;
    break;}
case 55:
#line 398 "pnl.y"
{	yyval.pop = Parse_Init_Pop( yyvsp[-1].ival, yyvsp[0].rlist );
		;
    break;}
case 56:
#line 407 "pnl.y"
{	yyval.routing = Parse_Routing( 'R', yyvsp[-1].rlist, (Liste_Address)NULL );
		;
    break;}
case 57:
#line 410 "pnl.y"
{	yyval.routing = Parse_Routing( 'D', (Liste_Reel)NULL, yyvsp[-1].alist );
		;
    break;}
case 58:
#line 413 "pnl.y"
{	yyval.routing = Parse_Routing( 'P', (Liste_Reel)NULL, yyvsp[-1].alist );
		;
    break;}
case 59:
#line 416 "pnl.y"
{	yyval.routing = Parse_Routing( 'C', (Liste_Reel)NULL, 
							(Liste_Address)NULL );
		;
    break;}
case 60:
#line 422 "pnl.y"
{	yyval.rlist = Expand_Real_List( yyvsp[-3].rval, yyvsp[-1].ival );
		;
    break;}
case 61:
#line 425 "pnl.y"
{	yyval.rlist = Append_Real( yyvsp[-1].rlist, yyvsp[0].rval );
		;
    break;}
case 62:
#line 428 "pnl.y"
{	yyval.rlist = Append_Real( (Liste_Reel)NULL, yyvsp[0].rval );
		;
    break;}
case 63:
#line 431 "pnl.y"
{	yyval.rlist = (Liste_Reel)NULL;
		;
    break;}
case 64:
#line 436 "pnl.y"
{	yyval.Llist = Append_Law( (Liste_Loi)NULL, yyvsp[0].loi );
		;
    break;}
case 65:
#line 439 "pnl.y"
{	yyval.Llist = Append_Law( yyvsp[-2].Llist, yyvsp[0].loi );
		;
    break;}
case 66:
#line 452 "pnl.y"
{	yyval.llist = Append_Link( (Liste_Link)NULL, yyvsp[0].llist );
		;
    break;}
case 67:
#line 455 "pnl.y"
{	yyval.llist = Append_Link( yyvsp[-2].llist, yyvsp[0].llist );
		;
    break;}
case 68:
#line 460 "pnl.y"
{       yyval.llist = yyvsp[0].llist;
		;
    break;}
case 69:
#line 463 "pnl.y"
{       yyval.llist = yyvsp[-1].llist;
			yyval.llist->Is_Inhibitor = TRUE;
		;
    break;}
case 70:
#line 485 "pnl.y"
{	yyval.llist = Parse_Link( yyvsp[0].aval, 1, "" );
		;
    break;}
case 71:
#line 488 "pnl.y"
{	yyval.llist = Parse_Link( yyvsp[-1].aval, yyvsp[0].ival, "" );
		;
    break;}
case 72:
#line 491 "pnl.y"
{	yyval.llist = Parse_Link( yyvsp[-1].aval, 1, yyvsp[0].sval );
		;
    break;}
case 73:
#line 494 "pnl.y"
{	yyval.llist = Parse_Link( yyvsp[-2].aval, yyvsp[-1].ival, yyvsp[0].sval );
		;
    break;}
case 74:
#line 499 "pnl.y"
{
			yyval.aval = Parse_Address( 'I', yyvsp[0].ival, (Address)NULL );
		;
    break;}
case 75:
#line 503 "pnl.y"
{
			yyval.aval = Parse_Address( 'O', yyvsp[0].ival, (Address)NULL );
		;
    break;}
case 76:
#line 509 "pnl.y"
{
			yyval.aval = Parse_Address( 'S', yyvsp[-2].ival, yyvsp[0].aval );
		;
    break;}
case 77:
#line 513 "pnl.y"
{
			yyval.aval = Parse_Address( 'P', yyvsp[0].ival, (Address)NULL );
		;
    break;}
case 78:
#line 517 "pnl.y"
{
			yyval.aval = Parse_Address( 'T', yyvsp[0].ival, (Address)NULL );
		;
    break;}
case 79:
#line 521 "pnl.y"
{
			yyval.aval = Parse_Address( 'U', yyvsp[0].ival, (Address)NULL );
		;
    break;}
case 80:
#line 527 "pnl.y"
{
			yyval.alist = Append_Address( yyvsp[0].aval, (Liste_Address)NULL );
		;
    break;}
case 81:
#line 531 "pnl.y"
{
			yyval.alist = Append_Address( yyvsp[0].aval, yyvsp[-1].alist );
		;
    break;}
case 82:
#line 535 "pnl.y"
{
			yyval.alist = (Liste_Address)NULL;
		;
    break;}
case 83:
#line 541 "pnl.y"
{
		        yyval.bval = yyvsp[0].bval;
		;
    break;}
case 84:
#line 545 "pnl.y"
{
		  	yyval.bval = (Binding) NULL;
		;
    break;}
case 85:
#line 551 "pnl.y"
{
			yyval.bval = Append_Binding( yyvsp[-1].bval, yyvsp[0].bval );
		;
    break;}
case 86:
#line 556 "pnl.y"
{
			yyval.bval = Append_Binding( yyvsp[0].bval, (Binding)NULL );
		;
    break;}
case 87:
#line 566 "pnl.y"
{
			yyval.bval = Parse_Binding( yyvsp[-5].ival, yyvsp[-3].aval, yyvsp[-1].llist );
		;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 465 "/usr/lib/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;
}
#line 572 "pnl.y"

#include "pnl_lex.yy.c"
