/* definition file for external resources */
#include <stdio.h>

#define	TMP_DIR		0
#define	TMP_EGL_FILE	1
#define	TMP_EGL_FILE2	2
#define	TMP_MAT_FILE	3
#define	TMP_RES_FILE	4
#define	TMP_MK1_FILE	5
#define	EG2MATRIX	6
#define	EG2EG		7
#define	SCSCYC		8
#define	MK1		9

#define	NB_RESOURCES	10

#ifndef RESOURCES
#define RESOURCES

char	*Resource_Name[] = {
	"TMP_DIR",
	"TMP_EGL_FILE",
	"TMP_EGL_FILE2",
	"TMP_MAT_FILE",
	"TMP_RES_FILE",
	"TMP_MK1_FILE",
	"EG2MATRIX",
	"EG2EG",
	"SCSCYC",
	"MK1",
	NULL };

#include <unistd.h>

int	Access_Code[] = {
	W_OK,
	W_OK,
	W_OK,
	W_OK,
	W_OK,
	W_OK,
	X_OK,
	X_OK,
	X_OK,
	X_OK };

char	*Default_Value[] = {
	"/tmp",
	"/tmp/m_eg.egl",
	"/tmp/m_eg2.egl",
	"/tmp/m_eg.mat",
	"/tmp/m_eg.res",
	"/tmp/m_eg.dat",
	"eg2matrix",
	"eg2eg",
	"scscyc",
	"mk1",
	NULL };

boolean	Is_Essential[] = {
	FALSE,
	FALSE,
	FALSE,
	FALSE,
	FALSE,
	FALSE,
	TRUE,
	TRUE,
	TRUE,
	TRUE };

#endif
