/* header for the interface with (max,+) spectral analysis procedures */

#ifndef _SPECTRAL_H
#define _SPECTRAL_H

typedef struct {
  int	Numerator;
  int	Denominator;
} rational;

typedef struct SPECTRAL_ELEMENTS {
  rational	Cycle_Mean_Rational;
  double	Cycle_Mean_Double;
  int		Cyclicity;
  int		Transient_Length;
} *Spectral_Elements;

double plus( double a, double b );
double moins( double a, double b );

#endif
