/* Structures de donnees specifiques des chaines de Markov	 	*/

#include "global.h"

#ifndef _MC_H_
#define _MC_H_

#define DISCRETE	1
#define CONTINUOUS	2

#include "spmat.h"

#define SPARSE		1
#define FULL		2

typedef struct MARKOV_CHAIN {
  int			Time_Type;
  int			State_Space_Size;
  SP_Real_Matrix	Generator;
  SP_Real_Matrix	Reward;
  int			Init_State;
} *Markov_Chain;

extern Markov_Chain New_Markov_Chain( int, int );
extern void Write_Markov_Chain( FILE*, Markov_Chain );

#endif
