
/*  A Bison parser, made from tgl.y with Bison version GNU Bison version 1.22
  */

#define YYBISON 1  /* Identify Bison output.  */

#define	STRING	258
#define	INTGR	259
#define	SEP	260
#define	PARB	261
#define	PARE	262
#define	TASK_BEG	263
#define	LINK_BEG	264
#define	END	265
#define	LINK_ORIG	266
#define	LINK_DEST	267
#define	DATA	268
#define	PROGRAM	269
#define	LINK_SYNCH	270
#define	LINK_TYPE	271
#define	OR_LINK	272
#define	AND_LINK	273
#define	DEPTH	274
#define	SERV	275
#define	REAL	276
#define	EXPO	277
#define	ERLG	278
#define	BERN	279
#define	GEOM0	280
#define	GEOM1	281
#define	UNIF	282
#define	CST	283
#define	DISC	284
#define	ONOFF	285
#define	IPP	286
#define	HEXP	287
#define	PARETO	288
#define	WEIBULL	289
#define	LOGNO	290

#line 1 "tgl.y"


#include "taskgraph.h"

#define YYDEBUG 1

extern boolean		Debug;

extern Graph	 	*Parse_TG(Liste_Task, Liste_Link);
extern Liste_Task	Extract_Tasks(Liste_Object);
extern Liste_Link	Extract_Links(Liste_Object);
extern void		Free_Object_List(Liste_Object);
extern Task 		*Parse_Task(char*,char*,Law_Desc);
extern Link_Desc	Parse_Link(char*,Link_Desc);
extern Link_Desc	Parse_Data_Link(SType,BiPoint,Law_Desc);
extern Link_Desc	Parse_Program_Link(SType,BiPoint,int);
extern Law_Desc		Parse_Law(char Nom, Liste_Reel Params, 
				  Liste_Reel Params2, Liste_Loi The_SubLaws);
extern Liste_Object	Append_Object(Liste_Object,Liste_Object);
extern Liste_Object	Task2Object(Task*);
extern Liste_Object	Link2Object(Link_Desc);
extern BiPoint		Parse_Ends(char*,char*);

/* The result of the parsing is to be put into the (global!) variable	*/
/* The_Task_Graph. It is defined in "parse_tg.c".			*/
/* Before I used "yyval" but this does not work with flex/bison.	*/
#ifndef USE_YYLVAL
extern Graph	*The_Task_Graph;	
#endif

extern boolean	Parse_Debug;

#line 36 "tgl.y"
typedef union{
	int		ival;
	double		rval;
	char		*sval;
	BiPoint		bpval;
	Graph		*un_reseau;
	Law_Desc	loi;
	Link_Desc	link;
	Liste_Link	plist;
	Task		*task;
	Liste_Task 	tlist;
	Liste_Object	olist;
	Liste_Reel	rlist;
	Liste_Loi	Llist;
} YYSTYPE;

#ifndef YYLTYPE
typedef
  struct yyltype
    {
      int timestamp;
      int first_line;
      int first_column;
      int last_line;
      int last_column;
      char *text;
   }
  yyltype;

#define YYLTYPE yyltype
#endif

#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		111
#define	YYFLAG		-32768
#define	YYNTBASE	36

#define YYTRANSLATE(x) ((unsigned)(x) <= 290 ? yytranslate[x] : 51)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     2,     3,     4,     5,
     6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
    26,    27,    28,    29,    30,    31,    32,    33,    34,    35
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     2,     4,     7,     9,    11,    16,    22,    27,    33,
    39,    42,    45,    48,    53,    58,    63,    68,    73,    80,
    85,    90,    95,   100,   108,   113,   118,   125,   127,   131,
   134,   137,   140,   143,   145,   147
};

static const short yyrhs[] = {    37,
     0,    38,     0,    37,    38,     0,    39,     0,    40,     0,
     8,     3,    43,    10,     0,     8,     3,     3,    43,    10,
     0,     9,     3,    41,    10,     0,    16,    13,    42,    46,
    43,     0,    16,    14,    42,    46,    49,     0,    15,    18,
     0,    15,    17,     0,    20,    44,     0,    22,     6,    50,
     7,     0,    28,     6,    50,     7,     0,    24,     6,    50,
     7,     0,    25,     6,    50,     7,     0,    26,     6,    50,
     7,     0,    23,     6,     4,     5,    50,     7,     0,    27,
     6,    50,     7,     0,    33,     6,    50,     7,     0,    35,
     6,    50,     7,     0,    34,     6,    50,     7,     0,    29,
     6,    50,     7,     6,    50,     7,     0,    32,     6,    50,
     7,     0,    30,     6,    50,     7,     0,    31,     6,    21,
     5,    45,     7,     0,    44,     0,    45,     5,    44,     0,
    47,    48,     0,    11,     3,     0,    12,     3,     0,    19,
     4,     0,    21,     0,     4,     0,    50,     5,    21,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
    78,    93,    97,   102,   106,   112,   118,   126,   133,   137,
   143,   146,   152,   157,   161,   165,   169,   173,   177,   182,
   186,   190,   194,   198,   202,   206,   210,   217,   220,   225,
   230,   235,   240,   245,   248,   251
};

static const char * const yytname[] = {   "$","error","$illegal.","STRING","INTGR",
"SEP","PARB","PARE","TASK_BEG","LINK_BEG","END","LINK_ORIG","LINK_DEST","DATA",
"PROGRAM","LINK_SYNCH","LINK_TYPE","OR_LINK","AND_LINK","DEPTH","SERV","REAL",
"EXPO","ERLG","BERN","GEOM0","GEOM1","UNIF","CST","DISC","ONOFF","IPP","HEXP",
"PARETO","WEIBULL","LOGNO","reseau","liste_objects","object","task","link","link_dcl",
"synchro_dcl","service_dcl","loi_dcl","law_list","ends_dcl","orig_dcl","dest_dcl",
"depth_dcl","real_list",""
};
#endif

static const short yyr1[] = {     0,
    36,    37,    37,    38,    38,    39,    39,    40,    41,    41,
    42,    42,    43,    44,    44,    44,    44,    44,    44,    44,
    44,    44,    44,    44,    44,    44,    44,    45,    45,    46,
    47,    48,    49,    50,    50,    50
};

static const short yyr2[] = {     0,
     1,     1,     2,     1,     1,     4,     5,     4,     5,     5,
     2,     2,     2,     4,     4,     4,     4,     4,     6,     4,
     4,     4,     4,     7,     4,     4,     6,     1,     3,     2,
     2,     2,     2,     1,     1,     3
};

static const short yydefact[] = {     0,
     0,     0,     1,     2,     4,     5,     0,     0,     3,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,    13,
     6,     0,     0,     8,     7,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,    35,    34,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,    12,    11,
     0,     0,     0,     0,     0,    14,     0,    16,    17,    18,
    20,    15,     0,    26,     0,    25,    21,    23,    22,    31,
     9,     0,    30,     0,    10,    36,     0,     0,    28,     0,
    32,    33,    19,     0,     0,    27,    24,    29,     0,     0,
     0
};

static const short yydefgoto[] = {   109,
     3,     4,     5,     6,    14,    51,    12,    30,   100,    72,
    73,    93,    95,    55
};

static const short yypact[] = {    63,
    23,    35,    63,-32768,-32768,-32768,    10,    52,-32768,    55,
    19,    60,    46,    66,    67,    72,    73,    74,    75,    76,
    77,    78,    79,    80,    81,    82,    83,    84,    85,-32768,
-32768,    86,    86,-32768,-32768,    11,    88,    11,    11,    11,
    11,    11,    11,    11,    87,    11,    11,    11,    11,    56,
    89,    89,-32768,-32768,     9,    90,    12,    13,    16,    17,
    20,    24,    28,    91,    29,    32,    50,    51,-32768,-32768,
    94,    55,    92,    93,    95,-32768,    11,-32768,-32768,-32768,
-32768,-32768,    96,-32768,    19,-32768,-32768,-32768,-32768,-32768,
-32768,   100,-32768,   101,-32768,-32768,    58,    11,-32768,    59,
-32768,-32768,-32768,    62,    19,-32768,-32768,-32768,    98,    99,
-32768
};

static const short yypgoto[] = {-32768,
-32768,   103,-32768,-32768,-32768,    61,   -10,   -77,-32768,    41,
-32768,-32768,-32768,   -37
};


#define	YYLAST		116


static const short yytable[] = {    15,
    57,    58,    59,    60,    61,    62,    63,    99,    65,    66,
    67,    68,    10,    75,    53,    76,    75,    75,    78,    79,
    75,    75,    80,    81,    75,     7,    82,   108,    75,    11,
    83,    54,    75,    75,    84,    86,    75,     8,    87,    97,
    16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
    26,    27,    28,    29,    75,    75,    88,    89,    32,    33,
   104,    91,    75,   105,   103,   106,    75,    13,   107,    31,
     1,     2,    69,    70,    11,    34,    35,    36,    37,    38,
    39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
    49,    56,    74,    52,    77,    85,    90,   110,   111,    71,
    50,    98,   101,    92,   102,     9,     0,    64,     0,     0,
     0,    94,     0,     0,     0,    96
};

static const short yycheck[] = {    10,
    38,    39,    40,    41,    42,    43,    44,    85,    46,    47,
    48,    49,     3,     5,     4,     7,     5,     5,     7,     7,
     5,     5,     7,     7,     5,     3,     7,   105,     5,    20,
     7,    21,     5,     5,     7,     7,     5,     3,     7,    77,
    22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
    32,    33,    34,    35,     5,     5,     7,     7,    13,    14,
    98,    72,     5,     5,     7,     7,     5,    16,     7,    10,
     8,     9,    17,    18,    20,    10,    10,     6,     6,     6,
     6,     6,     6,     6,     6,     6,     6,     6,     6,     6,
     6,     4,    52,    33,     5,     5,     3,     0,     0,    11,
    15,     6,     3,    12,     4,     3,    -1,    21,    -1,    -1,
    -1,    19,    -1,    -1,    -1,    21
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/lib/bison.simple"

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Bob Corbett and Richard Stallman

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 1, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */


#ifndef alloca
#ifdef __GNUC__
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi)
#include <alloca.h>
#else /* not sparc */
#if defined (MSDOS) && !defined (__TURBOC__)
#include <malloc.h>
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
#include <malloc.h>
 #pragma alloca
#else /* not MSDOS, __TURBOC__, or _AIX */
#ifdef __hpux
#ifdef __cplusplus
extern "C" {
void *alloca (unsigned int);
};
#else /* not __cplusplus */
void *alloca ();
#endif /* not __cplusplus */
#endif /* __hpux */
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc.  */
#endif /* not GNU C.  */
#endif /* alloca not defined.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	return(0)
#define YYABORT 	return(1)
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#define YYLEX		yylex(&yylval, &yylloc)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
int yyparse (void);
#endif

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_bcopy(FROM,TO,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_bcopy (from, to, count)
     char *from;
     char *to;
     int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_bcopy (char *from, char *to, int count)
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 184 "/usr/lib/bison.simple"
int
yyparse()
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
      yyss = (short *) alloca (yystacksize * sizeof (*yyssp));
      __yy_bcopy ((char *)yyss1, (char *)yyss, size * sizeof (*yyssp));
      yyvs = (YYSTYPE *) alloca (yystacksize * sizeof (*yyvsp));
      __yy_bcopy ((char *)yyvs1, (char *)yyvs, size * sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) alloca (yystacksize * sizeof (*yylsp));
      __yy_bcopy ((char *)yyls1, (char *)yyls, size * sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 1:
#line 79 "tgl.y"
{
#ifdef USE_YYLVAL
			yyval.un_reseau = Parse_TG( Extract_Tasks( yyvsp[0].olist ), 
						   Extract_Links( yyvsp[0].olist ) );
#else
			The_Task_Graph = Parse_TG( Extract_Tasks( yyvsp[0].olist ), 
						   Extract_Links( yyvsp[0].olist ) );
#endif
			Free_Object_List( yyvsp[0].olist );
			if ( Debug )
			  printf("Reseau ok\n");
		;
    break;}
case 2:
#line 95 "tgl.y"
{	yyval.olist = Append_Object( NULL, yyvsp[0].olist );
		;
    break;}
case 3:
#line 98 "tgl.y"
{	yyval.olist = Append_Object( yyvsp[-1].olist, yyvsp[0].olist );
		;
    break;}
case 4:
#line 104 "tgl.y"
{	yyval.olist = Task2Object( yyvsp[0].task );
		;
    break;}
case 5:
#line 108 "tgl.y"
{	yyval.olist = Link2Object( yyvsp[0].link );
		;
    break;}
case 6:
#line 114 "tgl.y"
{ 	yyval.task = Parse_Task( yyvsp[-2].sval, (char *)NULL, yyvsp[-1].loi );
			if (Parse_Debug)
				printf("Task %s recognized\n",yyvsp[-2].sval);
		;
    break;}
case 7:
#line 120 "tgl.y"
{ 	yyval.task = Parse_Task( yyvsp[-3].sval, yyvsp[-2].sval, yyvsp[-1].loi );
			if (Parse_Debug)
				printf("Task %s recognized\n",yyvsp[-3].sval);
		;
    break;}
case 8:
#line 127 "tgl.y"
{ 	yyval.link = Parse_Link( yyvsp[-2].sval, yyvsp[-1].link );
			if (Parse_Debug)
				printf("Link %s recognized\n",yyvsp[-2].sval);
		;
    break;}
case 9:
#line 135 "tgl.y"
{	yyval.link = Parse_Data_Link( yyvsp[-2].ival, yyvsp[-1].bpval, yyvsp[0].loi );
		;
    break;}
case 10:
#line 139 "tgl.y"
{	yyval.link = Parse_Program_Link( yyvsp[-2].ival, yyvsp[-1].bpval, yyvsp[0].ival );
		;
    break;}
case 11:
#line 144 "tgl.y"
{	yyval.ival = AND;
		;
    break;}
case 12:
#line 148 "tgl.y"
{	yyval.ival = OR;
		;
    break;}
case 13:
#line 153 "tgl.y"
{	yyval.loi = yyvsp[0].loi;
		;
    break;}
case 14:
#line 158 "tgl.y"
{	yyval.loi = Parse_Law( 'E', yyvsp[-1].rlist, (Liste_Reel)NULL,
					(Liste_Loi)NULL );
		;
    break;}
case 15:
#line 162 "tgl.y"
{	yyval.loi = Parse_Law( 'C', yyvsp[-1].rlist, (Liste_Reel)NULL,
					(Liste_Loi)NULL );
		;
    break;}
case 16:
#line 166 "tgl.y"
{	yyval.loi = Parse_Law( 'B', yyvsp[-1].rlist, (Liste_Reel)NULL,
					(Liste_Loi)NULL );
		;
    break;}
case 17:
#line 170 "tgl.y"
{	yyval.loi = Parse_Law( 'g', yyvsp[-1].rlist, (Liste_Reel)NULL,
					(Liste_Loi)NULL );
		;
    break;}
case 18:
#line 174 "tgl.y"
{	yyval.loi = Parse_Law( 'G', yyvsp[-1].rlist, (Liste_Reel)NULL,
					(Liste_Loi)NULL );
		;
    break;}
case 19:
#line 178 "tgl.y"
{	yyval.loi = Parse_Law( 'R', Append_Real( yyvsp[-1].rlist, (double)yyvsp[-3].ival ),
					(Liste_Reel)NULL,
					(Liste_Loi)NULL );
		;
    break;}
case 20:
#line 183 "tgl.y"
{	yyval.loi = Parse_Law( 'U', yyvsp[-1].rlist, (Liste_Reel)NULL,
					(Liste_Loi)NULL );
		;
    break;}
case 21:
#line 187 "tgl.y"
{	yyval.loi = Parse_Law( 'p', yyvsp[-1].rlist, (Liste_Reel)NULL,
					(Liste_Loi)NULL );
		;
    break;}
case 22:
#line 191 "tgl.y"
{	yyval.loi = Parse_Law( 'L', yyvsp[-1].rlist, (Liste_Reel)NULL,
					(Liste_Loi)NULL );
		;
    break;}
case 23:
#line 195 "tgl.y"
{	yyval.loi = Parse_Law( 'W', yyvsp[-1].rlist, (Liste_Reel)NULL,
					(Liste_Loi)NULL );
		;
    break;}
case 24:
#line 199 "tgl.y"
{	yyval.loi = Parse_Law( 'D', yyvsp[-4].rlist, yyvsp[-1].rlist,
					(Liste_Loi)NULL );
		;
    break;}
case 25:
#line 203 "tgl.y"
{	yyval.loi = Parse_Law( 'H', yyvsp[-1].rlist, (Liste_Reel)NULL,
					(Liste_Loi)NULL );
		;
    break;}
case 26:
#line 207 "tgl.y"
{	yyval.loi = Parse_Law( 'O', yyvsp[-1].rlist, (Liste_Reel)NULL,
					(Liste_Loi)NULL );
		;
    break;}
case 27:
#line 211 "tgl.y"
{	yyval.loi = Parse_Law( 'P',
					Append_Real( (Liste_Reel)NULL, yyvsp[-3].rval),
					(Liste_Reel)NULL, yyvsp[-1].Llist );
		;
    break;}
case 28:
#line 218 "tgl.y"
{	yyval.Llist = Append_Law( (Liste_Loi)NULL, yyvsp[0].loi );
		;
    break;}
case 29:
#line 221 "tgl.y"
{	yyval.Llist = Append_Law( yyvsp[-2].Llist, yyvsp[0].loi );
		;
    break;}
case 30:
#line 226 "tgl.y"
{	yyval.bpval = Parse_Ends( yyvsp[-1].sval, yyvsp[0].sval );
		;
    break;}
case 31:
#line 231 "tgl.y"
{	yyval.sval = yyvsp[0].sval;
		;
    break;}
case 32:
#line 236 "tgl.y"
{	yyval.sval = yyvsp[0].sval;
		;
    break;}
case 33:
#line 241 "tgl.y"
{	yyval.ival = yyvsp[0].ival;
		;
    break;}
case 34:
#line 246 "tgl.y"
{	yyval.rlist = Append_Real( (Liste_Reel)NULL, yyvsp[0].rval );
		;
    break;}
case 35:
#line 249 "tgl.y"
{	yyval.rlist = Append_Real( (Liste_Reel)NULL, (double)yyvsp[0].ival );
		;
    break;}
case 36:
#line 252 "tgl.y"
{	yyval.rlist = Append_Real( yyvsp[-2].rlist, yyvsp[0].rval );
		;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 465 "/usr/lib/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;
}
#line 256 "tgl.y"

#include "tgl_lex.yy.c"
