%{
extern double atof();
extern int    atoi();
extern char   *strcpy();
int	      TGL_lineno = 1;
%}

%%
TASK		return( TASK_BEG );
LINK		return( LINK_BEG );
END		return( END );

TYPE		return( LINK_TYPE );
DATA		return( DATA );
PROGRAM		return( PROGRAM );
DEPTH		return( DEPTH );

IS		return( LINK_SYNCH );
OPTIONAL	return( OR_LINK );
NECESSARY	return( AND_LINK );

FROM		return( LINK_ORIG );
TO		return( LINK_DEST );

DURATION	return( SERV );
BER		return( BERN );
CST		return( CST  );
DISC		return( DISC );
EXP		return( EXPO );
GEOSHIFT	return( GEOM1 );
GEOM		return( GEOM0 );
HEXP		return( HEXP );
LOGNORMAL	return( LOGNO );
ONOFF		return( ONOFF );
PARETO		return( PARETO );
IPP		return( IPP );
ERL		return( ERLG );
UNIF		return( UNIF );
WEIBULL		return( WEIBULL );
[(]		return( PARB );
[)]		return( PARE );
[0-9]+		{
			yylval.ival = atoi(yytext);
			return( INTGR );
		}
[0-9]+\.[0-9]*	{
			yylval.rval = atof(yytext);
			return( REAL );
		}
[a-zA-Z][a-zA-Z0-9_\.]* {
			yylval.sval = 
				(char*) malloc( (1+strlen(yytext))*sizeof(char) );
			yylval.sval = strcpy( yylval.sval, yytext );
			return( STRING );
		}
[,]             return( SEP );
\#.*$		;
[ \t]+		;
[\n]		{
			TGL_lineno++;
		}
.               printf("Illegal caracter: %s\n", yytext);
